(*Ŀ
  Source                                                                  
                                                                  
                                                                            
                 Water originaly made by D-PhSSD!                        
                Converted to Pascal by Anders Haglund.                      
     Convertit (partiellement) en franais par Haypo (haypo@ifrance.com)    
Ĵ
  Info                                                                    
                                                                    
                                                                            
                            Press ESC to quit                               
*)

{$M 1024,0,65535}
{$G+ : Utilise les fonctions du 286 }

{$DEFINE VSync}  { Se syncronyse avec l'cran   }

const
  RndInitial = $9234;
  DensiteInitial : word = 0005;

  Borde = 0002;

  LargVague  = 160;
  LargVagueX = 2;

  HVague = 100;
  HVagueMax = 150;
  LargEcran : word = 320;
  AutrePage  : word = HVague*LargVague*2;
  PageActuelle : word = 0;

  GS = $65;    { Utilise le segment GS (uniquement avec un 386 ou mieux) }

const palette : array[0..150*3-1] of byte = (
{ Couleur du fond }
  63,63,63,

{ Degrade noir -> bleu de l'eau }
              $3C,$3F,$3F,$3A,$3F,$3F,$37,$3E,$3F,$34,$3E,$3F,$32,
  $3E,$3F,$2F,$3E,$3F,$2D,$3D,$3F,$2A,$3D,$3F,$29,$3C,$3F,$28,$3B,
  $3F,$27,$3B,$3F,$27,$3B,$3F,$26,$3A,$3F,$25,$39,$3F,$24,$38,$3F,
  $23,$37,$3F,$22,$37,$3F,$21,$36,$3F,$20,$35,$3F,$1F,$34,$3F,$1E,
  $33,$3F,$1D,$32,$3F,$1C,$31,$3F,$1B,$30,$3F,$1A,$2F,$3F,$19,$2E,
  $3F,$18,$2D,$3F,$17,$2C,$3F,$16,$2A,$3F,$15,$29,$3F,$14,$28,$3F,

{ Degrade noir -> rouge du ponton }
  $13,$27,$3F,$12,$25,$3E,$11,$25,$3D,$11,$23,$3D,$10,$22,$3C,$0F,
  $20,$3B,$0F,$20,$3A,$0E,$1E,$39,$0D,$1D,$39,$0C,$1B,$38,$0C,$1B,
  $37,$0B,$19,$36,$0B,$18,$35,$0A,$16,$35,$09,$16,$34,$09,$14,$33,

{ Degrade rouge -> blanc du ponton }
  $08,$13,$32,$07,$12,$31,$07,$11,$31,$06,$10,$30,$06,$0F,$2F,$05,
  $0E,$2F,$05,$0D,$2E,$04,$0C,$2D,$04,$0B,$2C,$03,$0A,$2B,$03,$09,
  $2B,$02,$08,$2A,$02,$07,$29,$02,$06,$28,$01,$06,$27,$01,$04,$27,
  $01,$04,$26,$01,$04,$26,$01,$04,$26,$01,$04,$25,$01,$04,$25,$01,
  $04,$25,$01,$04,$24,$00,$04,$24,$00,$04,$24,$00,$04,$23,$00,$03,
  $23,$00,$03,$22,$00,$03,$22,$00,$03,$22,$00,$03,$21,$00,$03,$21,
  $00,$03,$21,$00,$03,$20,$00,$03,$20,$00,$03,$20,$00,$03,$20,$00,
  $03,$1F,$00,$03,$1F,$00,$03,$1F,$00,$03,$1E,$00,$03,$1E,$00,$02,
  $1E,$00,$02,$1D,$00,$02,$1D,$00,$02,$19,$00,$02,$16,$00,$01,$12,
  $00,$01,$0F,$00,$00,$0A,$00,$00,$05,$00,$00,$00,$0E,$00,$00,$13,
  $00,$00,$18,$00,$00,$1D,$00,$00,$22,$00,$00,$27,$00,$00,$2C,$00,
  $00,$31,$00,$00,$34,$00,$00,$38,$00,$00,$37,$00,$00,$36,$00,$02,
  $35,$00,$04,$35,$00,$05,$34,$00,$08,$33,$00,$09,$33,$00,$0A,$32,
  $00,$0B,$31,$00,$0C,$30,$00,$0D,$30,$01,$0E,$2F,$00,$0F,$2E,$00,
  $10,$2E,$00,$10,$2D,$00,$12,$2C,$01,$13,$2C,$01,$14,$2B,$01,$14,
  $2A,$01,$15,$29,$01,$16,$29,$01,$16,$28,$01,$17,$29,$03,$19,$2A,
  $05,$1B,$2C,$08,$1D,$2D,$0B,$1F,$2E,$0D,$20,$2F,$10,$22,$31,$13,
  $25,$32,$17,$27,$33,$1A,$29,$34,$1E,$2B,$36,$21,$2D,$37,$25,$30,
  $38,$29,$32,$3A,$2D,$34,$3B,$31,$37,$3C,$36,$3A,$3E,$3A,$3C,

{ Ciel blanc }
  $3F,$3F,$3F);

var Imr,Densidad : byte;
    Rnd,A,B : word;
    Fil,Col : array[0..4] of word;
    Buff2 : Pointer;
    Key : Boolean;

procedure InitBuffers; begin
  GetMem (buff2,65535);

  asm
    { Efface le buff2 }
    mov es,word ptr [buff2+2]
    xor di,di
    mov cx,65536/4
    db 66h; xor ax,ax
    db 66h; rep stosw

    { Initialise ES et FS }
    mov es,sega000
    mov ax,word ptr [buff2+2]
  { mov fs,ax } db 8Eh,0E8h
  end;
end;

procedure ModeTxt; assembler; asm
  mov ax,0003h
  int 10h
end;

procedure ModeVga256; assembler; asm
  mov ax,0013h
  int 10h
end;

Procedure ChangeGrandePal (Var palette; Debut: Byte; NCoul: word); Assembler; Asm
  push ds           { Sauve DS (vaut mieux) }

  mov dx,03C6h      { Port[3C6h] -> Port du cache de la palette }
  mov al,0FFh       { AL=Cache = 255 (Aucun) }
  out dx,al

  mov dx,3C8h       { Port[3C8h] -> Port d'criture dans la palette }
  mov al,Debut      { AL = Premire couleur  changer = 'debut' }
  out dx,al

  inc dx            { Port[3C9h] -> Port de donne de la palette }
  lds si,[palette]  { DS:[SI] -> Pointe sur la nouvelle palette }
  mov ax,[NCoul]
  mov cx,ax
  shl ax,1
  add cx,ax         { CX = Nombre de couleur*3  lire (3 primaires) }
  rep outsb         { Effectue l'criture }

  pop ds            { Recharge DS }
End;

procedure Fin; begin
  ModeTxt;
  Halt;
end;

procedure AffichePage; assembler; asm
   Mov     Si,PageActuelle
   Mov     Di,64000
   Mov     Cx,LargVague
@4:
   Push    Di
   Push    Cx
   Xor     Ax,Ax
   Xor     Dx,Dx
   Xor     Bx,Bx
@3:
   Db GS; Mov     Cx,[Si]
   Sar     Cx,7
   Add     Cx,Ax
   Sub     Cx,Dx
   Jle     @1
   Add     Dx,Cx
@2:
   Mov     Word Ptr Es:[Di],Bx
   Sub     Di,LargEcran
   Loop    @2
@1:
   Add     Si,2
   Add     Bx,0101H
   Inc     Ax
   Cmp     Ax,HVague
   Jnz     @3
   Mov     Dh,Dl
@5:
   Sub     Di,LargEcran
   Mov     Word Ptr Es:[Di],Dx
   Add     Dx,0101H
   Cmp     Dx,HVagueMax+HVagueMax*256;
   Jnz     @5
   Pop     Cx
   pop     Di
   Add     Di,2
   Loop    @4
{$IfDef VSync}
  mov dx,3DAh                   { Port d'tat du contrleur cran            }

@LeTubeDessine :
  in al,dx                      { Lit l'tat                                 }
  test al,8                     { Bit 3 : Le tube catodique travail ?        }
  jnz @LeTubeDessine            { Oui, on attend qu'il finisse               }

@LeTubeRevient :
  in al,dx                      { Relit l'tat                               }
  test al,8                     { Bit 3 : Le tube catodique a fini son       }
                                { travail ?                                  }
  jz @LeTubeRevient             { Non, on l'attend                           }
{$Endif}
   In Al,60h
   Cmp Al,1
   Jnz @Skip
   Call Fin
@Skip:
end;

procedure Stabylize; assembler; asm
   Mov     Si,[PageActuelle]
   Mov     Di,[AutrePage]
   Mov     [PageActuelle],Di
   Mov     [AutrePage],Si
   Add     Si,Borde*HVague
   Add     Di,Borde*HVague
   Mov     Cl,[Densidad]
   Mov     Bx,LargVague*HVague/2-Borde*HVague/2
@1:
   db 66h;db GS;Mov Ax,Word Ptr [Si-HVague*2]
   db 66h;db GS;Add Ax,Word Ptr [Si+HVague*2]
   db 66h;db GS;Add Ax,Word Ptr [Si+2]
   db 66h;db GS;Add Ax,Word Ptr [Si-2]
   db 66h;Ror     Ax,16
   Sar     Ax,1
   db 66h;Ror     Ax,16
   Sar     Ax,1
   db 66h;db GS;Sub     Ax,Word Ptr [Di]
   db 66h;Mov     Dx,Ax
   Sar     Dx,Cl
   db 66h;Ror     Dx,16
   Sar     Dx,Cl
   db 66h;Ror     Dx,16
   db 66h;Sub     Ax,Dx
   db 66h;db GS;Mov     Word Ptr [Di],Ax
   Add     Si,4
   Add     Di,4
   Dec     Bx
   Jnz     @1
end;

procedure Stabylize2; assembler; asm
   Mov     Si,Word Ptr [PageActuelle]
   Mov     Di,Word Ptr [AutrePage]
   Mov     Word Ptr [PageActuelle],Di
   Mov     Word Ptr [AutrePage],Si
   Add     Si,Borde*HVague
   Add     Di,Borde*HVague
   Mov     Cx,LargVague*HVague-Borde*HVague-100
@@1:
   db GS;Mov     Ax,Word Ptr [Si-HVague*2]
   db GS;Add     Ax,Word Ptr [Si+HVague*2]
   db GS;Add     Ax,Word Ptr [Si+2]
   db GS;Add     Ax,Word Ptr [Si-2]
   db GS;Add     Ax,Word Ptr [Si-HVague*2-2]
   db GS;Add     Ax,Word Ptr [Si-HVague*2-2]
   db GS;Add     Ax,Word Ptr [Si+HVague*2-2]
   db GS;Add     Ax,Word Ptr [Si+HVague*2-2]
   Sar     Ax,3
   db GS;Mov     Word Ptr [Di],Ax
   Add     Si,2
   Add     Di,2
   Loop    @@1
end;

procedure PutPixel; assembler; asm
   Mov Ax,Si
   db 66h; Rol Si,16
   Mov Si,Ax
   Mov Ax,HVague
   Mul Dx
   Add Bx,Ax
   Shl Bx,1
   Add Bx,Word Ptr [PageActuelle]
   db 66h; db GS; Mov Word Ptr [Bx+HVague*0  ],Si
   db 66h; db GS; Mov Word Ptr [Bx+HVague*0+4],Si
   db 66h; db GS; Mov Word Ptr [Bx+HVague*2  ],Si
   db 66h; db GS; Mov Word Ptr [Bx+HVague*2+4],Si
   db 66h; db GS; Mov Word Ptr [Bx+HVague*4  ],Si
   db 66h; db GS; Mov Word Ptr [Bx+HVague*4+4],Si
   db 66h; db GS; Mov Word Ptr [Bx+HVague*6  ],Si
   db 66h; db GS; Mov Word Ptr [Bx+HVague*6+4],Si
end;

procedure PutBigPixel; assembler; asm
   Mov     Ax,Si
   db 66h;Rol     Si,16
   Mov     Si,Ax
   Mov     Ax,HVague
   Mul     Dx
   Add     Bx,Ax
   Shl     Bx,1
   Add     Bx,Word Ptr [PageActuelle]
   db 66h;db GS;Mov     word Ptr [Bx],si
   db 66h;db GS;Mov     word Ptr [Bx+4],si
   db 66h;db GS;Mov     word Ptr [Bx+8],si
   db 66h;db GS;Mov     word Ptr [Bx+10],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*2)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*2+4)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*2+8)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*2+10)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*4)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*4)+4],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*4)+8],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*4)+10],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*6)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*6)+4],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*6)+8],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*6)+10],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*8)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*8)+4],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*8)+8],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*8)+10],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*10)],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*10)+4],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*10)+8],si
   db 66h;db GS;Mov     word Ptr [Bx+(HVague*10)+10],si
end;

procedure Rnd_Calc; assembler; asm
   Inc     Rnd
   Xor     Dx,Dx
   Mov     Ax,Rnd
   Mov     Bx,32719
   Mul     Bx
   Add     Ax,3
   Mov     Bx,32749
   Div     Bx
   Add     Dx,0F000H
   Mov     Rnd,Dx
end;

procedure Read_Point; assembler; asm
   Call    Rnd_Calc
   And     Dx,11111111B
   Add     Dx,32
   Push    Dx
   Call    Rnd_Calc
   Mov     Bx,Dx
   Pop     Dx
   And     Bx,1111111B
   Add     Bx,36
end;

procedure Touch;assembler; asm
   db 66h;Push    si
   Call    Read_Point
   db 66h;Pop     si
   Shr     Dx,1
   Call    PutPixel
end;

procedure Big_Touch; assembler; asm
   db 66h;Push    si
   Call    Read_Point
   db 66h;Pop     si
   Shr     Dx,1
   Call    PutBigPixel
end;

procedure PutLine; assembler; asm
   Mov  Ax,Si
   db 66h; Rol si,16
   Mov Si,Ax
   Mov Ax,HVague*2
   Mul Dx
   Mov Bx,Ax
   Add Bx,LargVagueX
   Mov Cx,HVague/2-LargVagueX
   Add Bx,2*8
   Sub Cx,2*8
@@1:
   db 66h; db GS; Mov word Ptr [Bx+ HVague* 0],si
   db 66h; db GS; Mov word Ptr [Bx+ HVague* 2],si
   db 66h; db GS; Mov word Ptr [Bx+ HVague* 4],si
   db 66h; db GS; Mov word Ptr [Bx+ HVague* 6],si
   db 66h; db GS; Mov word Ptr [Bx+ HVague* 8],si
   db 66h; db GS; Mov word Ptr [Bx+ HVague*10],si
   Add Bx,4
   Loop @@1
end;

procedure Fila; assembler; asm
   Dw      025,025,026,027,028,030,032,034,037,039,042,045
   Dw      048,052,055,058,061,063,066,068,070,072,073,074
   Dw      075,075,075,074,073,072,070,068,066,063,061,058
   Dw      055,052,048,045,042,039,037,034,032,030,028,027
   Dw      026,025
   Dd      0Ffffffffh
end;

procedure Columna; assembler; asm
   Dw      015,015,016,016,017,018,020,021,023,025,027,030
   Dw      033,036,039,042,045,049,052,056,060,064,068,072
   Dw      076,080,084,088,092,096,000,104,108,111,115,118
   Dw      121,124,127,130,133,135,137,139,140,142,143,144
   Dw      144,145,145,145,144,144,143,142,140,139,137,135
   Dw      133,130,127,124,121,118,115,111,108,104,100,096
   Dw      092,088,084,080,076,072,068,064,060,056,052,049
   Dw      045,042,039,036,033,030,027,025,023,021,020,018
   Dw      017,016,016,015
   Dd      0Ffffffffh
end;
procedure Read_Sinus; assembler; asm
   Shl     A,1
@@11:
   Mov     Bx,A
   Mov     Si,Word Ptr [Fil+Bx]
   Mov     Cx,Word Ptr [Fila+Si]
   Cmp     Cx,0Ffffh
   Jnz     @@1
   Mov     Bx,A
   Mov     Word Ptr [Fil+Bx],0
   Jmp     @@11
@@1:
   Mov     Bx,A
   Mov     Si,Word Ptr [Col+Bx]
   Mov     Dx,Word Ptr [Columna+Si]
   Cmp     Dx,0Ffffh
   Jnz     @@2
   Mov     Bx,A
   Mov     Word Ptr [Col+Bx],0
   Jmp     @@1
@@2:
   Mov     Bx,A
   Add     Word Ptr [Col+Bx],2
   Add     Word Ptr [Fil+Bx],2
   Mov     Bx,Cx
end;

procedure Clear_Sinus; assembler; asm
   Mov     Word Ptr [Col],10
   Mov     Word Ptr [Col+2],20
   Mov     Word Ptr [Col+4],40
   Mov     Word Ptr [Col+6],0
   Mov     Word Ptr [Col+8],0
   Mov     Word Ptr [Fil],50
   Mov     Word Ptr [Fil+2],20
   Mov     Word Ptr [Fil+4],40
   Mov     Word Ptr [Fil+6],40
   Mov     Word Ptr [Fil+8],0
end;

procedure Touch_Sinus; assembler; asm
   db 66h;Push si
   push a
   Call Read_Sinus
   pop a
   db 66h;Pop si
   Call PutPixel
end;

procedure InitEcran; assembler; asm
  Call AffichePage
  Call [Stabylize]
end;

procedure Density(Densidad_Variable : Word);
{Mov     Byte [Densidad],Densidad_Variable}
inline ($58/$88/$06/>Densidad);

procedure P001; assembler; asm
   Xor     Si,Si
   Mov     Cx,40
@@2:
   Push    Cx
   Mov     Cx,3
@@1:
   Push    Cx
   Push    Si
   Call    Big_Touch
   Call    Stabylize
   Call    AffichePage
   Call    Stabylize
   Call    AffichePage
   Call    Stabylize
   Call    AffichePage
   Call    Stabylize
   Call    AffichePage
   Pop     Si
   Pop     Cx
   Loop    @@1
   Add     Si,25
   Pop     Cx
   Loop    @@2
   Mov     Cx,40
@@12:
   Push    Cx
   Mov     Cx,3
@@11:
   Push    Cx
   Push    Si
   Call    Big_Touch
   Call    Stabylize
   Call    AffichePage
   Call    Stabylize
   Call    AffichePage
   Call    Stabylize
   Call    AffichePage
   Call    Stabylize
   Call    AffichePage
   Pop     Si
   Pop     Cx
   Loop    @@11
   Sub     Si,20
   Pop     Cx
   Loop    @@12
end;

procedure P002; assembler; asm
   Mov     Cx,5
@@2:
   Push    Cx
   Mov     Si,3000
   Mov     Dx,320/4
   Mov     Bx,150
   Call    PutPixel
   Mov     Cx,50
@@3:
   Push    Cx
   Mov     Si,300
   Call    Touch
   Mov     Si,200
   Call    Touch
   Mov     Si,100
   Call    Touch
   Call    Stabylize
   Call    AffichePage
   Pop     Cx
   Loop    @@3
   Pop     Cx
   Loop    @@2
   Mov     Cx,80
@@4:
   Push    Cx
   Call    Stabylize
   Call    AffichePage
   Pop     Cx
   Loop    @@4
end;

procedure P003; assembler; asm
   Mov     Cx,30
@@1:
   Push    Cx
   Mov     Si,-4000
   Call    Big_Touch
   Call    Stabylize2
   Call    AffichePage
   Mov     Si,-4000
   Call    Big_Touch
   Call    Stabylize2
   Call    AffichePage
   Mov     Si,-4000
   Call    Big_Touch
   Call    Stabylize2
   Call    AffichePage
   Pop     Cx
   Loop    @@1
   Mov     Cx,20
@@4:
   Push    Cx
   Call    Stabylize2
   Call    AffichePage
   Pop     Cx
   Loop    @@4
end;
procedure P004; assembler; asm
   Mov     Cx,7
@@2:
   Push    Cx
   Mov     Si,3000
   Mov     Dx,320/4
   Mov     Bx,150
   Call    PutPixel
   Mov     Cx,5
@@3:
   Push    Cx
   Call    Stabylize
   Call    AffichePage
   Pop     Cx
   Loop    @@3
   Mov     Si,-2000
   Mov     Dx,320/4
   Mov     Bx,150
   Call    PutPixel
   Mov     Cx,30
@@6:
   Push    Cx
   Call    Stabylize
   Call    AffichePage
   Pop     Cx
   Loop    @@6
   Pop     Cx
   Loop    @@2
   Mov     Cx,80
@@4:
   Push    Cx
   Call    Stabylize
   Call    AffichePage
   Pop     Cx
   Loop    @@4
end;

procedure P005; assembler; asm
   Mov     Si,800
   Mov     Cx,150
@@1:
   Push    Cx
   db 66h;Push    si
   Push    A
   Cmp     A,4
   Jz      @@5
   Cmp     A,3
   Jz      @@4
   Cmp     A,2
   Jz      @@3
   Cmp     A,1
   Jz      @@2
   mov a,0
   Call Touch_Sinus
@@2:
   mov a,1
   Call Touch_Sinus
@@3:
   mov a,2
   Call Touch_Sinus
@@4:
   mov a,3
   Call Touch_Sinus
@@5:
   mov a,4
   Call Touch_Sinus
   Mov     Cx,B
   Mov     Bx,Offset Stabylize
   Call    InitEcran
   Pop     A
   db 66h;Pop     si
   Pop     Cx
   Loop    @@1
end;

procedure P006; assembler; asm
   Mov     Si,-1500
   Mov     Cx,4
@@1:
   Push    Cx
   Push    Si
   Mov     Dx,1
   Cmp     A,0
   Jz      @@S1
   Call    PutLine
@@S1:
   Mov     Cx,50
@@3:
   Push    Cx
   Mov     Si,250
   Cmp     B,0
   Jz      @@S2
   Call    Touch
@@S2:
   Call    Stabylize
   Call    AffichePage
   Call    Stabylize
   Call    AffichePage
   Pop     Cx
   Loop    @@3
   Pop     Si
   Pop     Cx
   Loop    @@1
end;

procedure Stabylize_Water; assembler; asm
   Mov     Cx,100
   Mov     Bx,Offset Stabylize
   Call    InitEcran
end;

procedure SetAB (C,D : Word);Assembler; asm
   Mov Ax,C
   Mov A,Ax
   Mov Ax,D
   Mov B,Ax
end;
procedure ChangePal (Index, R,V,B: Byte); assembler; Asm
  mov al,0FFh
  mov dx,03C6h
  out dx,al

  mov dx,03C8h
  mov al,[index]
  out dx,al

  mov dx,03C9h

  mov al,[R]
  out dx,al

  mov al,[V]
  out dx,al

  mov al,[B]
  out dx,al
end;

begin
  InitBuffers;

  ModeVga256; ChangeGrandePal (palette,0,150);

  Density (DensiteInitial);

  InitEcran;

  asm
    Push Es
    Mov Ax,0A000H
    Mov Es,Ax
    Mov Di,320*101
    Mov Cx,320/4
    Mov Ax,6363H
    db 66h; Shl Ax,16
    Mov Ax,6363H
    db 66h; Rep Stosw
    Pop Es
  end;

  repeat
    asm Mov Rnd,RndInitial end;

    Density(DensiteInitial);
    P001;
    P002;
    Density(6);
    P003;
    Stabylize_Water;
    P003;
    Stabylize_Water;
    Density(5);
    P004;
    Stabylize_Water;
    Clear_Sinus;
    SetAB(4,2);
    P005;
    SetAB(3,2);
    P005;
    SetAB(2,2);
    P005;
    SetAB(4,1);
    P005;
    SetAB(4,1);
    P005;
    SetAB(3,2);
    P005;
    Density(6);
    SetAB(1,0);
    P006;
    SetAB(1,1);
    P006;
    SetAB(0,1);
    P006;
  until False;
end.